' <summary>
' 
' Chris Blankenship : [http://www.dscoduc.com]
' Version 1.0
' December 17th, 2007
' 
' Tested and verified on BlogEngine.Net v1.2.0.0
' 
' The purpose of this extension is to provide a profile page for which authenticated users
' can manage their email address and passwords. 
' 
' </summary>
Imports System
Imports System.Web
Imports System.Web.UI.WebControls

Partial Class admin_Pages_CBXADVBlogger
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Page.IsPostBack = False Then
            Me.ddlPages.Items.Clear()
            For index As Integer = 0 To BlogEngine.Core.Page.Pages.Count - 1
                Dim page As BlogEngine.Core.Page
                page = BlogEngine.Core.Page.Pages(index)
                Me.ddlPages.Items.Add(New ListItem(page.Title, page.Id.ToString))
                Me.ddlParentPageList.Items.Add(New ListItem(page.Title, page.Id.ToString))
                Me.clbChildPages.Items.Add(New ListItem(page.Title, page.Id.ToString))
                Me.clbMultiDelete.Items.Add(New ListItem(page.Title, page.Id.ToString))
            Next
        End If
    End Sub

    Protected Sub btnSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        If User.Identity.IsAuthenticated Then
            Me.clbSearchbResults.Items.Clear()
            For index As Integer = 0 To BlogEngine.Core.Page.Pages.Count - 1
                Dim page As BlogEngine.Core.Page
                page = BlogEngine.Core.Page.Pages(index)
                If page.Content.Contains(Me.txtSearch.Text) Then
                    Me.clbSearchbResults.Items.Add(New ListItem(page.Title, page.Id.ToString))
                End If
            Next
        End If
    End Sub

    Protected Sub btnReplace_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnReplace.Click
        If User.Identity.IsAuthenticated Then
            For Each cb As ListItem In clbSearchbResults.Items
                If cb.Selected Then
                    Dim page As BlogEngine.Core.Page
                    page = BlogEngine.Core.Page.GetPage(New Guid(cb.Value))
                    If page.Content.Contains(Me.txtSearch.Text) Then

                        Dim pos As Integer = page.Content.IndexOf(Me.txtSearch.Text)
                        If pos <> -1 Then
                            page.Content = page.Content.Remove(pos, Me.txtSearch.Text.Length)
                            page.Content = page.Content.Insert(pos, Me.txtReplace.Text)
                            page.Save()
                        End If
                    End If
                End If
            Next
        End If
    End Sub

    Protected Sub btnDuplicate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDuplicate.Click
        If User.Identity.IsAuthenticated AndAlso String.IsNullOrEmpty(Me.ddlPageID.Value) = False AndAlso Me.txtDuplicatePageTitle.Text <> String.Empty Then
            Dim page As BlogEngine.Core.Page
            page = BlogEngine.Core.Page.GetPage(New Guid(Me.ddlPageID.Value))
            If page IsNot Nothing Then
                Dim newPage As New BlogEngine.Core.Page()
                newPage.Title = Me.txtDuplicatePageTitle.Text
                newPage.Content = page.Content

                BlogEngine.Core.Page.Pages.Add(newPage)
            End If
        End If
    End Sub

    Protected Sub ddlPages_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlPages.SelectedIndexChanged
        Me.ddlPageID.Value = Me.ddlPages.SelectedItem.Value
    End Sub

    Public Function UrlIsValid(ByVal Url As String) As Boolean
        Dim sStream As IO.Stream
        Dim URLReq As Net.HttpWebRequest
        Dim URLRes As Net.HttpWebResponse

        Try
            URLReq = Net.WebRequest.Create(Url)
            URLRes = URLReq.GetResponse()
            sStream = URLRes.GetResponseStream()
            'Dim reader As New IO.StreamReader(sStream)
            sStream.ReadByte()
            'reader.Read()
            Return True
        Catch ex As Exception
            'Url not valid
            Return False
        End Try
    End Function

    Protected Sub btnCheckForBrkenLinks_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCheckForBrkenLinks.Click
        If User.Identity.IsAuthenticated Then
            Dim linklist As New Specialized.StringCollection
            Me.clbBrokenLinks.Items.Clear()
            For index As Integer = 0 To BlogEngine.Core.Page.Pages.Count - 1
                Dim page As BlogEngine.Core.Page
                page = BlogEngine.Core.Page.Pages(index)

                Dim reader As New Sgml.SgmlReader
                Dim sett As New System.Xml.XmlReaderSettings

                reader.InputStream = New IO.StringReader(page.Content)
                reader.SetBaseUri(page.AbsoluteLink.ToString)
                reader.DocType = "HTML"
                While reader.Read
                    If reader.NodeType = System.Xml.XmlNodeType.Element AndAlso _
                    reader.Name.ToLower = "a" AndAlso _
                    reader.HasAttributes Then
                        Dim href As String = reader.GetAttribute("href")

                        Dim url As Uri = Nothing
                        If Uri.TryCreate(href, UriKind.RelativeOrAbsolute, url) Then
                            If url.IsAbsoluteUri = False Then
                                Dim absurl As Uri = Nothing
                                If Uri.TryCreate(page.AbsoluteLink, UriKind.Absolute, absurl) Then
                                    url = New Uri(absurl, url)
                                Else
                                    ' error
                                End If
                            End If

                            linklist.Add(url.AbsoluteUri)
                            'If UrlIsValid(url.AbsoluteUri) = False Then
                            '    Dim found As Boolean
                            '    found = False

                            '    For Each tmp As ListItem In Me.clbBrokenLinks.Items
                            '        If tmp.Value = page.Id.ToString Then
                            '            found = True
                            '            Exit For
                            '        End If
                            '    Next

                            '    If found = False Then Me.clbBrokenLinks.Items.Add(New ListItem(page.Title, page.Id.ToString))
                            'End If
                        End If
                    End If
                End While
            Next

        End If
    End Sub

    Protected Sub rblTools_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles rblTools.SelectedIndexChanged
        Select Case Me.rblTools.SelectedIndex
            Case 0
                Me.HidePanels()
                Me.pnlContentSearchAndReplace.Visible = True
            Case 1
                Me.HidePanels()
                Me.pnlPageDuplicator.Visible = True
            Case 2
                Me.HidePanels()
                Me.pnlBrokenPageLinks.Visible = True
                Me.CheckForBrokenLinks()
            Case 3
                Me.HidePanels()
                Me.pnlDeadPages.Visible = True
            Case 4
                Me.HidePanels()
                Me.pnlSetParent.Visible = True
            Case 5
                Me.HidePanels()
                Me.pnlStats.Visible = True
            Case 6
                Me.HidePanels()
                Me.pnlMultiPageDelete.Visible = True
        End Select
    End Sub

    Private Sub CheckForBrokenLinks()

    End Sub

    Private Sub HidePanels()
        Me.pnlBrokenPageLinks.Visible = False
        Me.pnlContentSearchAndReplace.Visible = False
        Me.pnlPageDuplicator.Visible = False
        Me.pnlDeadPages.Visible = False
        Me.pnlSetParent.Visible = False
        Me.pnlStats.Visible = False
        Me.pnlMultiPageDelete.Visible = False
    End Sub

    Protected Sub btnSetParentPage_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSetParentPage.Click

        For Each Item As ListItem In Me.clbChildPages.Items
            If Item.Selected Then
                Dim page As BlogEngine.Core.Page
                page = BlogEngine.Core.Page.GetPage(New Guid(Item.Value))
                page.Parent = New Guid(Me.hfParentPage.Value)
            End If
        Next
        For Each Item As ListItem In Me.clbChildPages.Items
            Item.Selected = False
        Next

    End Sub

    Protected Sub ddlParentPageList_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlParentPageList.SelectedIndexChanged
        Me.hfParentPage.Value = Me.ddlParentPageList.SelectedItem.Value
    End Sub

    Protected Sub btnMultiDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnMultiDelete.Click
        For Each Item As ListItem In Me.clbMultiDelete.Items
            If Item.Selected Then
                Dim page As BlogEngine.Core.Page
                page = BlogEngine.Core.Page.GetPage(New Guid(Item.Value))
                page.Delete()
            End If
        Next
        For Each Item As ListItem In Me.clbMultiDelete.Items
            Item.Selected = False
        Next
    End Sub
End Class
